import java.awt.*;
import java.awt.print.*;
import java.util.ArrayList;

import javax.swing.*;

public class PrintTest2Panel extends JPanel implements Printable {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//
	String[] stringData;
	//̃y[WƊey[W擪
	int page;
	int[] lineStart;
	int[] charStart;
	//̈ݒł̃y[W`FbNi̍ŏɂPxj
	boolean pageCheck;
	//
	public PrintTest2Panel(){
		setBackground(Color.WHITE);
		//
		stringData=new String[0];
		pageCheck=false;
	}
	public void setString(String[] s){
		stringData=s;
	}
	//ʂւ̕`
	public void paintComponent(Graphics g){
		super.paintComponent(g);
		//̕Ɖs̍߂邽ߕKv
		FontMetrics metrics=g.getFontMetrics();
		//͂̋
		int margin=10;
		//̕\ʒu
		int px=margin;
		int py=margin+metrics.getHeight();
		//PÂʒuw肵ĕ`iʉɉB͍̂lĂȂj
		for(int l=0;l<stringData.length;l++){
			for(int c=0;c<stringData[l].length();c++){
				g.drawString(String.valueOf(stringData[l].charAt(c)),px,py);
				//\ʒu𕶎EɈړ
				px+=metrics.charWidth(stringData[l].charAt(c));
				//E[ɗsiŌ͂̕ݏo邪Amargin邩炢Ƃj
				if(px>getWidth()-2*margin){
					px=margin;
					py+=metrics.getHeight();
				}
			}
			//̍s
			px=margin;
			py+=metrics.getHeight();
		}
	}
	//v^[ւ̏o
	public int print(Graphics g, PageFormat fmt, int index) throws PrinterException {
		//̕Ɖs̍߂邽ߕKv
		FontMetrics metrics=g.getFontMetrics();
		//y[W`FbNĂȂ΂
		if(!pageCheck){
			chaeckPageAttribute(metrics,fmt);
		}
		//
		if(index>=page){						//͈͊Õy[WȂANO_SUCH_PAGEԂ
			pageCheck=false;	//̏̈Iił͐VȏŃy[W`FbNj
			return NO_SUCH_PAGE;
		}else{									//͈͓̃y[WȂ`悵āAPAGE_EXISTSԂ
			//\ȍʒu
			int x=(int)fmt.getImageableX();
			int y=(int)fmt.getImageableY();
			g.translate(x,y);
			//̕\ʒu
			int px=0;
			int py=metrics.getHeight();
			//PÂʒuw肵ĕ`
			for(int l=lineStart[index];l<stringData.length;l++){
				//ŏ̍śAŝߓr̕炩Ȃ
				int s;
				if(l!=lineStart[index]){
					s=0;
				}else{
					s=charStart[index];
				}
				//
				for(int c=s;c<stringData[l].length();c++){
					//̏ꍇ͈\̈ł͂ݏoĂ͂Ȃ
					int w=px+metrics.charWidth(stringData[l].charAt(c));
					//̕Eɂ͂ݏoȂA̍sɂ
					if(w>fmt.getImageableWidth()){
						px=0;
						py+=metrics.getHeight();
						//ɂ͂ݏoȂy[WI
						if(py>fmt.getImageableHeight()){
							return PAGE_EXISTS;
						}
					}
					//P`
					g.drawString(String.valueOf(stringData[l].charAt(c)),px,py);
					//\ʒu𕶎EɈړ
					px+=metrics.charWidth(stringData[l].charAt(c));
				}
				//s̍Ō̕܂ŕ`悵Is
				px=0;
				py+=metrics.getHeight();
				//ɂ͂ݏoȂy[WI
				if(py>fmt.getImageableHeight()){
					return PAGE_EXISTS;
				}
			}
			//Ō܂ŕ`悵Iy[WI
			return PAGE_EXISTS;
		}
	}
	//̈ݒŉy[WɂȂAey[W̐擪͂ǂɂȂ邩i̍ŏɂPxj
	private void chaeckPageAttribute(FontMetrics metrics,PageFormat fmt){
		ArrayList<Integer> lineArray=new ArrayList<Integer>();
		ArrayList<Integer> charArray=new ArrayList<Integer>();
		//̕\ʒu
		int px=0;
		int py=metrics.getHeight();
		//ŏ̃y[W
		lineArray.add(Integer.valueOf(0));
		charArray.add(Integer.valueOf(0));
		//PÂʒumFi`͂AŏŌ܂ŗăy[WmFj
		for(int l=0;l<stringData.length;l++){
			for(int c=0;c<stringData[l].length();c++){
				//̏ꍇ͈\̈ł͂ݏoĂ͂Ȃ
				int w=px+metrics.charWidth(stringData[l].charAt(c));
				//̕Eɂ͂ݏoȂA̍sɂ
				if(w>fmt.getImageableWidth()){
					px=0;
					py+=metrics.getHeight();
					//ɂ͂ݏoȂ玟y[W
					if(py>fmt.getImageableHeight()){
						px=0;
						py=metrics.getHeight();
						//y[W̐擪i[
						lineArray.add(Integer.valueOf(l));
						charArray.add(Integer.valueOf(c));
					}
				}
				//ŕ`͂Ȃ
				//\ʒu𕶎EɈړiŉEɂ͂ݏo邱Ƃ͂܂j
				px+=metrics.charWidth(stringData[l].charAt(c));
			}
			//s̍Ō̕܂ŏIs
			px=0;
			py+=metrics.getHeight();
			//ɂ͂ݏoȂ玟y[W
			if(py>fmt.getImageableHeight()){
				px=0;
				py=metrics.getHeight();
				//ŏIsłȂ΁Ay[W̐擪i[iŏIsȂSďIj
				if(l!=stringData.length-1){
					lineArray.add(Integer.valueOf(l+1));
					charArray.add(Integer.valueOf(0));
				}
			}
		}
		//y[W`FbŇʂZbg
		page=lineArray.size();
		lineStart=new int[page];
		charStart=new int[page];
		for(int p=0;p<page;p++){
			lineStart[p]=((Integer)lineArray.get(p)).intValue();
			charStart[p]=((Integer)charArray.get(p)).intValue();
		}
		//`FbNς݂ɂ
		pageCheck=true;
	}

}
