//*************************************************************
//Java application
//uPrintTest2v
//
//@@@@@@@@@@@@ҁF[g؁@@@
//@@@@@@@@@@쐬JnFQOOV^Q
//@@@@@@@@@@ŏIXVFQOOV^Q      [TN111/J101]
//*************************************************************
import java.awt.*;
import java.awt.event.*;
import java.awt.print.*;
import java.io.*;
import java.util.ArrayList;

import javax.print.*;
import javax.print.attribute.*;
import javax.print.event.*;
import javax.swing.*;

public class PrintTest2 extends JFrame implements ActionListener,PrintJobListener {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//
	public static void main(String[] args) {
		PrintTest2 frame=new PrintTest2();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);	//E~ŏI
		frame.setVisible(true);
		frame.setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//iieLXg\plj
	PrintTest2Panel panel;
	//iieLXgt@Cwj
	String fileName="text file not selected";
	JButton selectButton=new JButton("eLXgt@CI");
	JLabel fileLabel=new JLabel(fileName);
	//iiwj
	JButton printNoDialogButton=new JButton("W̃v^[");
	JButton printDialogButton=new JButton("_CAO\");
	JButton printNoDialogButtonSimple=new JButton("W̃v^[");
	JButton printDialogButtonSimple=new JButton("_CAO\");
	//
	public PrintTest2(){
		//
		setTitle("PrintTest2");
		setSize(500,600);
		//
		JPanel panel2=new JPanel();
		panel2.setLayout(new GridLayout(2,1));
		panel2.add(fileLabel);
		panel2.add(selectButton);
		//
		JPanel panel3=new JPanel();
		panel3.setLayout(new GridLayout(2,3));
		panel3.add(new JLabel(" javax.print ň"));
		panel3.add(printNoDialogButton);
		panel3.add(printDialogButton);
		panel3.add(new JLabel(" java.awt.print ň"));
		panel3.add(printNoDialogButtonSimple);
		panel3.add(printDialogButtonSimple);
		//Reig
		Container cp=getContentPane();
		cp.add(panel=new PrintTest2Panel(),BorderLayout.CENTER);
		cp.add(panel2,BorderLayout.NORTH);
		cp.add(panel3,BorderLayout.SOUTH);
		//
		selectButton.addActionListener(this);
		printNoDialogButton.addActionListener(this);
		printDialogButton.addActionListener(this);
		printNoDialogButtonSimple.addActionListener(this);
		printDialogButtonSimple.addActionListener(this);
		//eLXgt@CJ܂ł͖
		printNoDialogButton.setEnabled(false);
		printDialogButton.setEnabled(false);
		printNoDialogButtonSimple.setEnabled(false);
		printDialogButtonSimple.setEnabled(false);
	}
	//{^Cxg
	public void actionPerformed(ActionEvent e) {
		if(e.getSource()==selectButton){
			String file=getFileName();
			if(file!=null){
				fileName=file;
				fileLabel.setText(fileName);
				//
				String[] lines=loadTextFile(fileName);
				if(lines!=null){
					panel.setString(lines);
				}
				//
				printNoDialogButton.setEnabled(true);
				printDialogButton.setEnabled(true);
				printNoDialogButtonSimple.setEnabled(true);
				printDialogButtonSimple.setEnabled(true);
			}
			//
			repaint();
		}else if(e.getSource()==printNoDialogButton){
			printNoDialog();
		}else if(e.getSource()==printDialogButton){
			printDialog();
		}else if(e.getSource()==printNoDialogButtonSimple){
			printNoDialogSimple();
		}else if(e.getSource()==printDialogButtonSimple){
			printDialogSimple();
		}
	}
	//javax.print gp
	private void printNoDialog(){
		//IuWFNgMIME (Multipurpose Internet Mail Extensions) ^Cv̓
		DocFlavor flavor=DocFlavor.SERVICE_FORMATTED.PRINTABLE;
		//f[^Wuɗ^邽߂̃C^[tF[X
		DocAttributeSet das=new HashDocAttributeSet();
		Doc doc=new SimpleDoc(panel,flavor,das);
		//ǂ̂悤Ɉ邩
		PrintRequestAttributeSet pras=new HashPrintRequestAttributeSet();
		//ftHg̈T[rXiv^[EIuWFNgj擾
		PrintService defaultService=PrintServiceLookup.lookupDefaultPrintService();
		//***************************_CAO\******************************************
		//Wu쐬
		DocPrintJob job=defaultService.createPrintJob();
		//*************************************************************************************
		//֘ÃCxg󂯎悤ɂ
		job.addPrintJobListener(this);
		//
		try{
			job.print(doc,pras);
		}catch(PrintException e){
			JOptionPane.showMessageDialog(this,"Ɏs܂B","G[",JOptionPane.ERROR_MESSAGE);
			return;
		}
	}
	private void printDialog(){
		//IuWFNgMIME (Multipurpose Internet Mail Extensions) ^Cv̓
		DocFlavor flavor=DocFlavor.SERVICE_FORMATTED.PRINTABLE;
		//f[^Wuɗ^邽߂̃C^[tF[X
		DocAttributeSet das=new HashDocAttributeSet();
		Doc doc=new SimpleDoc(panel,flavor,das);
		//ǂ̂悤Ɉ邩
		PrintRequestAttributeSet pras=new HashPrintRequestAttributeSet();
		//ftHg̈T[rXiv^[EIuWFNgj擾
		PrintService defaultService=PrintServiceLookup.lookupDefaultPrintService();
		//****************************_CAO\********************************************
		//̕^Cv (GIFȂ) ̑Zbg (ʂȂ) ł̈T|[gv^[̃Zbg
		PrintService[] printServices=PrintServiceLookup.lookupPrintServices(flavor,pras);
		//v^[I_CAO\
		PrintService service=ServiceUI.printDialog(null,200,200,printServices,defaultService,flavor,pras);
		//Wu쐬
		DocPrintJob job;
		if(service!=null){
			job=service.createPrintJob();
		}else{
			return;
		}
		//*************************************************************************************
		//֘ÃCxg󂯎悤ɂ
		job.addPrintJobListener(this);
		//
		try{
			job.print(doc,pras);
		}catch(PrintException e){
			JOptionPane.showMessageDialog(this,"Ɏs܂B","G[",JOptionPane.ERROR_MESSAGE);
			return;
		}
	}
	//java.awt.print gp
	private void printNoDialogSimple(){
		//
		PrinterJob job=PrinterJob.getPrinterJob();
		/*̃hLg̏ꍇ͂iy[Wwj
		Book bk=new Book();
		bk.append(panel,job.defaultPage(),3);
		job.setPageable(bk);
		*/
		//****************************_CAO\******************************************
		//
		job.setPrintable(panel);
		//
		try{
			job.print();
		}catch(PrinterException e){
			JOptionPane.showMessageDialog(this,"Ɏs܂B","G[",JOptionPane.ERROR_MESSAGE);
			return;
		}
	}
	private void printDialogSimple(){
		//
		PrinterJob job=PrinterJob.getPrinterJob();
		/*̃hLg̏ꍇ͂iy[Wwj
		Book bk=new Book();
		bk.append(panel,job.defaultPage(),3);
		job.setPageable(bk);
		*/
		//****************************_CAO\********************************************
		//y[Wݒ_CAO
		PageFormat fmt=job.pageDialog(job.defaultPage());
		//
		job.setPrintable(panel,fmt);
		//WũvpeBύX_CAO
		if(job.printDialog()){
			try{
				job.print();
			}catch(PrinterException e){
				JOptionPane.showMessageDialog(this,"Ɏs܂B","G[",JOptionPane.ERROR_MESSAGE);
				return;
			}
		}
	}
	//t@C_CAO\ĖړIt@C̃pX擾iLZnullԂj
	private String getFileName(){
		//
		FileDialog fileDialog=new FileDialog(this);
		fileDialog.setMode(FileDialog.LOAD);
		fileDialog.setTitle("摜t@CI");
		fileDialog.setVisible(true);
		//
		String dir=fileDialog.getDirectory();
		String file=fileDialog.getFile();
		//
		if(file!=null){
			return dir+file;
		}else{
			return null;
		}
	}
	//w肳ꂽeLXgt@CJāAgԂ
	private String[] loadTextFile(String file){
		//
		BufferedReader br;
		try{
			br=new BufferedReader(new FileReader(file));
		}catch(FileNotFoundException e){
			JOptionPane.showMessageDialog(this,"t@C܂B","G[",JOptionPane.ERROR_MESSAGE);
			return null;
		}
		//
		ArrayList<String> lines=new ArrayList<String>();
		try{
			String line;
			while((line=br.readLine())!=null){
				lines.add(line);
			}
			br.close();
		}catch(IOException e){
			JOptionPane.showMessageDialog(this,"t@Cǂݍ݂Ɏs܂B","G[",JOptionPane.ERROR_MESSAGE);
			return null;
		}
		//
		String[] ret=new String[lines.size()];
		for(int l=0;l<lines.size();l++){
			ret[l]=(String)lines.get(l);
		}
		return ret;
	}
	//ŔCxg̊mFijavax.print ̂݁j
	public void printDataTransferCompleted(PrintJobEvent e){
		JOptionPane.showMessageDialog(this,"DataTransferCompleted ","PrintJob  Event",JOptionPane.INFORMATION_MESSAGE);
	}
	public void printJobCompleted(PrintJobEvent e){
		JOptionPane.showMessageDialog(this,"JobCompleted ","PrintJob  Event",JOptionPane.INFORMATION_MESSAGE);
	}
	public void printJobFailed(PrintJobEvent e){
		JOptionPane.showMessageDialog(this,"JobFailed ","PrintJob  Event",JOptionPane.INFORMATION_MESSAGE);
	}
	public void printJobCanceled(PrintJobEvent e){
		JOptionPane.showMessageDialog(this,"JobCanceled ","PrintJob  Event",JOptionPane.INFORMATION_MESSAGE);
	}
	public void printJobNoMoreEvents(PrintJobEvent e){
		JOptionPane.showMessageDialog(this,"JobNoMoreEvents ","PrintJob  Event",JOptionPane.INFORMATION_MESSAGE);
	}
	public void printJobRequiresAttention(PrintJobEvent e){
		JOptionPane.showMessageDialog(this,"JobRequiresAttention ","PrintJob  Event",JOptionPane.INFORMATION_MESSAGE);
	}
}
